import numpy as np


class SituationalKnowledge:

    # 1

    def __init__(self):
        self.best_fitness = 0.0
        self.best_x = 0.0
        self.best_y = 0.0
        self.weight = 0

    def accept(self, population):
        index = np.where(population.fitness == np.max(population.fitness))[0][0]
        if population.fitness[index] > self.best_fitness:
            self.best_x = population.x[index]
            self.best_y = population.y[index]
            self.best_fitness = population.fitness[index]
        print("best fitness: " + str(self.best_fitness))
        print("best x: " + str(self.best_x))
        print("best y: " + str(self.best_y))

    def influence(self, population):
        for i in range(population.individuals_n):
            if population.knowledge[i] == 1:
                population.x[i] += 0.1 * (self.best_x - population.x[i])
                population.y[i] += 0.1 * (self.best_y - population.y[i])
