import sys
from random import random

import numpy as np


class TopologicalKnowledge:

    # 3

    def __init__(self):
        self.weight = 0
        self.nx = 10
        self.ny = 10
        self.topology = np.zeros((self.nx, self.ny))

    def accept(self, population):
        self.topology = np.zeros((self.nx, self.ny))
        for i in range(population.individuals_n):
            self.topology[min(int(population.x[i]), 9)][min(int(population.y[i]), 9)] += 1

    def influence(self, population):
        sparse = np.where( self.topology == np.min(self.topology))
        for i in range(population.individuals_n):
            if population.knowledge[i] == 3:
                if random() < 0.5:
                    index = np.random.choice(len(sparse[0]))
                    population.x[i] = sparse[0][index] + random() * 10 / self.nx
                    population.y[i] = sparse[1][index] + random() * 10 / self.ny

        # print(self.topology)
        # print(np.sum(self.topology))
        # print(sparse)
